package jiniexamples.chapter10;

import net.jini.core.lookup.ServiceID;
import net.jini.core.event.RemoteEvent;
import net.jini.core.event.RemoteEventListener;
import net.jini.space.JavaSpace;
import java.rmi.server.UnicastRemoteObject;
import java.rmi.RemoteException;

public class MessageHandler extends UnicastRemoteObject
                            implements RemoteEventListener {
       
  protected RoomChatWindow chatwindow;
  protected JavaSpace javaspace;
      
  MessageHandler() throws RemoteException {
  }

  MessageHandler(JavaSpace js, RoomChatWindow chat) 
                                throws RemoteException {
    chatwindow= chat;
    javaspace = js;
  }
    
  public void notify(RemoteEvent e) {
    try { 
        RoomSpeak messobj = (RoomSpeak)javaspace.readIfExists(
                 new  RoomSpeak(chatwindow.getRoom(),null,null),
                 null, 
                 200);
        if (messobj != null) {
                 chatwindow.appendMessage(messobj);
        }
    } catch (Exception ex) {
        System.err.println("Error writing event: " + 
                               ex.getMessage());        
    }    
  }
}