package jiniexamples.chapter10;

import net.jini.lookup.ServiceDiscoveryManager;
import net.jini.core.lookup.ServiceTemplate;
import net.jini.core.lookup.ServiceItem;
import net.jini.space.JavaSpace;
import net.jini.lease.LeaseListener;
import net.jini.lease.LeaseRenewalEvent;
import net.jini.core.lease.Lease;
import com.sun.jini.lease.landlord.LandlordLease;
import net.jini.core.transaction.server.TransactionManager;
import net.jini.core.transaction.Transaction;
import net.jini.core.transaction.TransactionFactory;

import java.rmi.RMISecurityManager;
import java.util.Vector;


public class RoomBuilder {

 static ServiceDiscoveryManager sdm;
   
 public RoomBuilder() {
 }
   
 public static void main (String[] args)  {
   	
    if (args.length < 1) {            
       System.out.println("Usage: <file>");
       System.exit(1);        
    }
    try {
       System.setSecurityManager (new RMISecurityManager ());          
       sdm = new ServiceDiscoveryManager(null,null);    
       JavaSpace jspace = (JavaSpace) getService(sdm, JavaSpace.class);         
       if  (jspace != null){
            for (int i=0;i<args.length;i++){
                  // add the room to the Space..
                  jspace.write(new Room(args[i],new Vector()),
                               null, Lease.FOREVER );
             	  System.out.println(" Room " + args[i]+" added");
            }   
       }             
    } catch (Exception e) {
            System.out.println ("Roombuilder:main() exception: " + e);
    }
    sdm.terminate();
    System.exit(0);
  }
   
  public static Object getService(ServiceDiscoveryManager sdm, 
                                  Class classname){

   Class[] type = new Class[] {classname };
   ServiceTemplate template = new ServiceTemplate(null,type,null);

   try {
       ServiceItem serviceitem = sdm.lookup(template, 
                                           null, Long.MAX_VALUE);
       if ( serviceitem == null ) {
            System.out.println("Can't find service");
            return null;
       } else {
            return serviceitem.service;
       }
    } catch (Exception e) {
      System.out.println("Exception finding service :" + e);
      return null;
    }
 } 
}
