package jiniexamples.chapter10;

import net.jini.core.lookup.ServiceID;
import net.jini.core.event.RemoteEvent;
import net.jini.core.event.RemoteEventListener;
import net.jini.space.JavaSpace;

import javax.swing.JList;

import java.rmi.server.UnicastRemoteObject;
import java.rmi.RemoteException;

public class RoomHandler extends UnicastRemoteObject
                         implements RemoteEventListener {

  protected RoomChatWindow chatwindow;
  protected JavaSpace javaspace;


  RoomHandler() throws RemoteException {
  }

  RoomHandler(JavaSpace js, RoomChatWindow chat)
                                    throws RemoteException {
    chatwindow= chat;
    javaspace = js;
  }

  public void notify(RemoteEvent e) {
    try {
       Room theroom =
             (Room)javaspace.readIfExists(
                             new Room(chatwindow.getRoom(),null),
                             null, 200);
       if (theroom != null) {
         chatwindow.updateUserList(theroom.members);
       }

    } catch (Exception ex) {
          System.err.println("Error writing event: " + ex);
    }
  }
}