package jiniexamples.chapter10;

import net.jini.lookup.ServiceDiscoveryManager;
import net.jini.core.lookup.ServiceTemplate;
import net.jini.core.lookup.ServiceItem;
import net.jini.space.JavaSpace;
import net.jini.lease.LeaseListener;
import net.jini.lease.LeaseRenewalEvent;
import net.jini.core.lease.Lease;
import com.sun.jini.lease.landlord.LandlordLease;
import net.jini.core.transaction.server.TransactionManager;
import net.jini.core.transaction.Transaction;
import net.jini.core.transaction.TransactionFactory;

import java.rmi.RMISecurityManager;
import java.util.Vector;


public class RoomLister {
  static ServiceDiscoveryManager sdm;

  public RoomLister() {
  }

  public static void main (String[] args)  {

    Room room;

    try {
      System.setSecurityManager (new RMISecurityManager ());
      sdm = new ServiceDiscoveryManager(null,null);

      JavaSpace jspace = 
                    (JavaSpace) getService(sdm, JavaSpace.class);
      TransactionManager transManager =
             (TransactionManager)getService(sdm,
                                       TransactionManager.class);

      if  ((jspace != null) && ( transManager != null)){
        Transaction.Created trans =
           TransactionFactory.create(transManager,Lease.FOREVER);
        sdm.getLeaseRenewalManager().renewUntil(trans.lease,
                                                Lease.FOREVER,
                                                null);
        while ((room = (Room)jspace.take(new Room(),
                                        trans.transaction, 200) )
               != null){
                   System.out.println("Room Found  "+ room.name);
        }
        System.out.println("Abort Transacation  ");
        trans.transaction.abort();
        sdm.getLeaseRenewalManager().remove(trans.lease);
      }

    } catch (Exception e) {
        System.out.println (".main() exception: " + e);
    }
    sdm.terminate();
    System.exit(0);
  }

  public static Object getService(ServiceDiscoveryManager sdm,
                                  Class classname){

    Class[] type = new Class[] {classname };
    ServiceTemplate template = 
                            new ServiceTemplate(null,type,null);

    try {
      ServiceItem serviceitem =
                     sdm.lookup(template, null, Long.MAX_VALUE);
      // Use the Service if has been found.
      if ( serviceitem == null ) {
        System.out.println("Can't find service");
        return null;
      } else {
        return serviceitem.service;
      }
    } catch (Exception e) {
        System.out.println("Exception finding service :" + e);
        return null;
    }
  }
}
