package jiniexamples.chapter11;

import jiniexamples.chapter4.RemoteResource;

import java.io.File;
import java.rmi.RemoteException;
import java.rmi.MarshalledObject;
import java.rmi.activation.Activatable;
import java.rmi.activation.ActivationID;


public class ActivatableFileStore extends Activatable
                                  implements RemoteFileStore  {

  protected RemoteResource rootDir  = new RemoteResource();


  // ============= File Store Service  ================

  // Ammended to use the activation framework

  public  ActivatableFileStore(ActivationID id,
                               MarshalledObject data)
                                        throws RemoteException {
    super(id, 0);
  }



  public RemoteResource getParentFile(RemoteResource dir)
                                         throws RemoteException{

        File file = (File)dir.getContents();
        File parent = file.getParentFile();

        if (parent != null) {
                RemoteResource parentDir = new RemoteResource();

                parentDir.setContents (parent);
                parentDir.setName(parent.getName());
                parentDir.setDirectory(parent.isDirectory());

                return parentDir;
             }
        else {
                return null;
             }
   }

  public RemoteResource[] listFiles(RemoteResource dir)
                                          throws RemoteException{

     File file = (File)dir.getContents();
     File [] filelist = file.listFiles();

     if (filelist != null) {
        RemoteResource[] returnlist= 
                             new RemoteResource[filelist.length];

        for (int i = 0; i< filelist.length; i++){
           returnlist[i] = new RemoteResource();
           returnlist[i].setContents (filelist[i]);
           returnlist[i].setName(filelist[i].getName());
           returnlist[i].setDirectory(filelist[i].isDirectory());
        }
        return returnlist;
     } else {
        return null;
     }
  }

  public  RemoteResource getRoot()  throws RemoteException {
        File f = new  File( File.separator);

        RemoteResource rootDir = new RemoteResource();
        rootDir.setContents (f);
        rootDir.setName(f.getName());
        rootDir.setDirectory(f.isDirectory());

        return rootDir;
   }
}
