package jiniexamples.chapter11;

import jiniexamples.chapter4.RemoteResourceStore;
import jiniexamples.chapter4.RemoteResource;
import java.io.Serializable;
import java.rmi.RemoteException;


public class RemoteResourceServiceProxy  implements RemoteResourceStore,
                                                    Serializable {

    // Manage the local state associated with the service..

    protected RemoteFileStore backend;
    protected RemoteResource currentDir;

    public RemoteResourceServiceProxy() { // This is not normally called
    }

    public RemoteResourceServiceProxy(RemoteFileStore backend){
        this.backend = backend;
        try {
            currentDir = backend.getRoot();
          } catch (RemoteException ex) {
            System.out.println("Couldn't Set  root directory:"
                                + ex.getMessage());
          }
    }

    // Note each of the methods map between the methods
    // in the RemoteResourceStore interface and
    //  the RemoteFileStore interface.



     // GETCURRENTDIR
    public RemoteResource getCurrentDir(){
            return currentDir;

    }

     // SETCURRENTDIR
    public void setCurrentDir(RemoteResource dir){
        currentDir = dir;

    }

    // GETPARENT
    public RemoteResource getParent(RemoteResource dir)
                                         throws RemoteException {
        return backend.getParentFile(dir);

    }

    // CHANGEUPDIR
    public void changeUpdir() throws RemoteException {
         RemoteResource parent = 
                              backend.getParentFile(currentDir);
         if (parent != null) currentDir =parent;

    }

    // LISTRESOURCES
    public RemoteResource[] listResources()
                                        throws RemoteException {
            return backend.listFiles(currentDir);
    }

}
