package jiniexamples.chapter11;


import java.rmi.activation.Activatable;
import java.rmi.activation.ActivationID;
import java.rmi.MarshalledObject;
import java.rmi.RemoteException;
import net.jini.core.event.RemoteEvent;
import net.jini.core.event.RemoteEventListener;
import net.jini.core.lease.Lease;
import net.jini.lease.ExpirationWarningEvent;

public class RenewLeaseHandler extends Activatable
  implements RemoteEventListener {

  protected long leaseDuration = 24*60*60*1000;// 1 Day

  public RenewLeaseHandler(ActivationID id,
                           MarshalledObject data)
                                        throws RemoteException {
       super(id, 0);
       System.out.println(" RenewLeaseHandler Activated");
    }

  public void notify(RemoteEvent evnt) {

       ExpirationWarningEvent expevnt =
                                  (ExpirationWarningEvent) evnt;
       Lease lease = expevnt.getRenewalSetLease();
       try {
            lease.renew(leaseDuration);
       } catch(Exception e) {
            e.printStackTrace();
       }
           // Make it inactive again
       try {
             Activatable.inactive(this.getID());
       } catch (Exception e) {
           System.out.println ("error making inactive " + e);
       }
  }
}
