// Specialised render to draw the list of resources in the JList.
// Checks to see if the remote resource is a directory and shows
// a folder if it is.

package jiniexamples.chapter12;

import javax.swing.JList;
import javax.swing.JLabel;
import javax.swing.ImageIcon;
import javax.swing.ListCellRenderer;
import java.net.URL;
import jiniexamples.chapter4.RemoteResource;



import java.awt.Component;

public class FileCellRenderer extends JLabel
                                   implements ListCellRenderer {
      static ImageIcon folderIcon = null;

     FileCellRenderer() {

       try {
           folderIcon =
                   new ImageIcon(
                   new URL ("http://roddent/images/folder.gif"));
        } catch (Exception e) {
           folderIcon = null;
        }
     }
     // This is the only method defined by ListCellRenderer.
     // It reconfigures the component when called by JList.

     public Component getListCellRendererComponent(
        JList list,
        Object value,            // value to display
        int index,               // cell index
        boolean isSelected,      // is the cell selected
        boolean cellHasFocus)

     {
         RemoteResource f = (RemoteResource) value;
         setText(f.getName());
         if (f.isDirectory()) {
               setIcon(folderIcon);
            }
         else {
               setIcon(null);
            }

         if (isSelected) {
               setBackground(list.getSelectionBackground());
               setForeground(list.getSelectionForeground());
           }
         else {
               setBackground(list.getBackground());
               setForeground(list.getForeground());
           }
         setEnabled(list.isEnabled());
         setFont(list.getFont());
         return this;
     }
 }
