// A "smarter" proxy for the "Currency Converter service. 
// This one knows how to talk to a remote object
// that implements the BackendProtocol interface.

package jiniexamples.chapter3;

import jiniexamples.chapter2.CurrencyConvertServiceInterface;

import java.io.Serializable;
import java.rmi.Remote;
import java.rmi.RemoteException;

public class CurrencyConvertServiceProxy2 
    implements CurrencyConvertServiceInterface,
             Serializable {
    protected BackendProtocol backend;
    
    public CurrencyConvertServiceProxy2() {
    }
    
    public CurrencyConvertServiceProxy2(BackendProtocol       
                                     backend){
        this.backend = backend;
    }
    
    // Note convert() now calls backend.doconversion()

// The convert routine converts known values else it returns  
// the same value back.
    public float convert(float amount, String country){
    	
        try {
            return backend.doConversion(amount,country);
        } catch (RemoteException ex) {
            System.out.println( "Couldn't contact backend: " +
                   ex.getMessage());
            return amount;
        }
    }
    
} 
