// This FileServiceWrapper places the service proxy in Jini
// The main routine for this class creates an instance of the
// service  and the proxy used to access it. The service proxy  
// is added to a lookup manager by using the JoinManager 
package jiniexamples.chapter4;

import net.jini.core.lookup.ServiceID;
import net.jini.lookup.JoinManager;
import net.jini.lookup.ServiceIDListener;
import net.jini.discovery.LookupDiscoveryManager;
import java.io.IOException;
import java.rmi.RMISecurityManager;

public class FileServiceWrapper implements ServiceIDListener {

  public void serviceIDNotify(ServiceID serviceID)  {
      System.out.println("File Store Service ID is " +serviceID);
  }
    
  public FileServiceWrapper() {
 }

 // The main routine creates an instance of the service 
 // and then uses the JoinManager to make this available
 // to Jini 
  public static void main(String[] args) throws Exception { 
        // Set a security manager.
       if (System.getSecurityManager() == null) {
            System.setSecurityManager( new RMISecurityManager());
       }
       try{ // Set up all groups
            String[] allgroups = new String[] { "" };   
            // Create the instance of the service;    
            FileStoreService fileservice = 
                       (FileStoreService) new FileStoreService();
            // Create Proxy
            RemoteResourceServiceProxy serviceproxy = 
                     new RemoteResourceServiceProxy(fileservice);
            // the JoinManager gives proxy to lookupservices 
            // and to renew leases with the lookup services      
            LookupDiscoveryManager discoverymanager = 
                     new LookupDiscoveryManager(allgroups, null,
                                                null);
            JoinManager manager = 
                     new JoinManager(serviceproxy, null,
                                     new FileServiceWrapper(), 
                                     discoverymanager, null); 
       } catch (Exception ex) {
            ex.printStackTrace();
       }     
  }  
}