/* This is basic interface needed to allow people to manage
   a filestore. The interface keeps track of the current 
   directory. Provides lists of files in the directory 
   It allows a change up of the directory and a search 
   through the hierarchy    
   This interface will essentially provide the core 
   interface for the RMI and for the JINI version of 
   the browser.   
   This can be generalised and extended later. */
package jiniexamples.chapter4;

import java.rmi.RemoteException;

 public interface RemoteResourceStore  {
  
   public RemoteResource getCurrentDir() throws RemoteException;
  
   public void setCurrentDir(RemoteResource dir) 
                                        throws RemoteException;
                                        
   public RemoteResource getParent(RemoteResource dir) 
                                        throws RemoteException;
                                        
   public void changeUpdir() throws RemoteException;
   
   public RemoteResource[] listResources() 
                                        throws RemoteException;   
 }
