package jiniexamples.chapter4;
 
import net.jini.lookup.ServiceDiscoveryManager;
import net.jini.core.lookup.ServiceTemplate;
import net.jini.core.lookup.ServiceItem;
import java.rmi.RemoteException;
import java.rmi.RMISecurityManager;


public class SimpleFileClient  {
	
  RemoteResourceStore fs;
       
  public SimpleFileClient(RemoteResourceStore thefilestore) {
       fs =thefilestore;
  }
	
  public void displayFiles(){
       RemoteResource[] listing =null;
	
       try { 
           fs.getCurrentDir();
           listing = fs.listResources();    
       } catch ( RemoteException ex) {
           System.out.println("Error connecting to remote source"
                               +ex);
       }
       if (listing != null) {
           System.out.println("  ====File Listing========");
           show_dir(listing, "  ");
           System.out.println("   ====DONE========");
       }
  }
    
  public void show_dir(RemoteResource[] listing, String indent){

       for (int i=0;i<listing.length;i++){
          RemoteResource res = listing[i];
          if (res.isDirectory()) {
             try {
                 fs.setCurrentDir(res);
                 RemoteResource[] dirlist = fs.listResources();
                 show_dir(dirlist, indent +"  ");
                 fs.changeUpdir();
             } catch ( RemoteException ex) {
                 System.out.println("Remote Error " +ex);
             }
          } else {
             System.out.println(indent +  listing[i].getName());
          }
       }
     }
      
  public static void main (String[] args) { 
        // Set a security manager.
       if (System.getSecurityManager() == null) {
             System.setSecurityManager(new RMISecurityManager());
       }
       
       try {
           ServiceDiscoveryManager sdm = 
                        new ServiceDiscoveryManager(null,null);
           // Set up the template 
           Class[] classname = 
                        new Class[] {RemoteResourceStore.class};
           ServiceTemplate template = 
                        new ServiceTemplate(null,classname,null);
           // Block until a matching service is found
           ServiceItem serviceitem = 
                      sdm.lookup(template, null, Long.MAX_VALUE);
           
           // Use the Service if has been found.
           if ( serviceitem == null ) {
              System.out.println("Can't find service");
           } else {
              RemoteResourceStore servobj = 
                      (RemoteResourceStore) serviceitem.service;
             // Create and then use the simple file client
              SimpleFileClient cl = new SimpleFileClient(servobj);
              cl.displayFiles();
           }
       } catch (Exception e) {
           System.out.println ("client: main() exception: " + e);
       } 
   }     
}

