package jiniexamples.chapter5;

import jiniexamples.chapter4.RemoteResourceStore;
import jiniexamples.chapter4.RemoteFileBrowser;

import javax.swing.JFrame;
import java.awt.Component;
import java.awt.BorderLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import net.jini.core.entry.Entry;
import net.jini.core.lookup.ServiceTemplate;
import net.jini.core.lookup.ServiceItem;
import net.jini.lookup.ServiceDiscoveryManager;
import net.jini.lookup.entry.EntryBeans;
import net.jini.lookup.entry.EntryBean;

import java.rmi.RMISecurityManager;


public class AmmendedBrowser {
	  
  public static void main (String[] args) {
    try {
       if (System.getSecurityManager() == null) {
            System.setSecurityManager( new RMISecurityManager());
       }
          
       ServiceDiscoveryManager sdm = 
                           new ServiceDiscoveryManager(null,null);
         // Set up the template 
       Class[] name = new Class[] {RemoteResourceStore.class}; 
       ServiceTemplate template 
                      = new ServiceTemplate(null,name,null);
          
        // Block until a matching service is found
       ServiceItem serviceitem 
                   = sdm.lookup(template, null, Long.MAX_VALUE);
         // Use the Service if has been found.
       if ( serviceitem == null  ) {
           System.out.println("Can't find service");
       } else {
           RemoteResourceStore servobj 
                     = (RemoteResourceStore) serviceitem.service;
           Entry[] attset = serviceitem.attributeSets;
           Capacity capval= null;
           RemoteFileBrowser contentPane 
                        = new RemoteFileBrowser(servobj);

           for (int i=0 ;  i<attset.length ; i++) {
              if (attset[i] instanceof Capacity) {
                 capval = (Capacity) attset[i];
                 break;
              }
           }  
           EntryBean  capbean = null;  	
           if (capval != null) {
               capbean = EntryBeans.createBean(capval);
               if (capbean != null && 
                   (capbean instanceof Component)) {
                          contentPane.add(((Component)capbean),
                                            BorderLayout.SOUTH);
               } 
           }
           JFrame browserframe =
                     new JFrame("Simple RemoteResource Browser");

           browserframe.addWindowListener(new WindowAdapter() {
              public void windowClosing(WindowEvent e) {
                 System.exit(0);
               }
           });
           browserframe.setContentPane(contentPane);
           browserframe.pack();
           browserframe.setVisible(true);          
       }
    } catch (Exception e)  {
       System.out.println ("client: main() exception: " + e);
    }
  }
}
