
package jiniexamples.chapter5;

import jiniexamples.chapter4.RemoteResourceServiceProxy;
import jiniexamples.chapter4.FileStoreService;

import net.jini.core.entry.Entry;
import net.jini.discovery.LookupDiscoveryManager;
import net.jini.lookup.JoinManager;
import net.jini.lookup.entry.Location;
import net.jini.lookup.entry.Name;
import java.io.File;
import java.io.IOException;
import java.rmi.RMISecurityManager;


public class AttributeServiceWrapper extends PersistentServiceWrapper  {
  protected JoinManager join = null;
  protected File serFile = null;
  protected static String serviceName = "Unamed";
   
    

  public AttributeServiceWrapper(Object proxy,
                                 File serFile, 
                                 boolean firsttime) 
                    throws IOException, ClassNotFoundException {
                    	
       this.serFile = serFile;
       if (System.getSecurityManager() == null) {
            System.setSecurityManager( new RMISecurityManager());
       }
        
       if (firsttime) {
            register(proxy);
       } else {
            reregister(proxy);
       }
  } 
    
    // replace with code that interogates local resources
  public int max_capacity() {
       return 300; // This would be replace with JNI code
  }

  public int used_capacity() {
       return 150; // This would be replace with JNI code
  }
    
  protected void register(Object serviceproxy) throws IOException {
       if (join != null) {
          throw new IllegalStateException(
                                     "Wrapper already started.");
       }
            
       System.out.println("Starting...");
       LookupDiscoveryManager luMgr =
            new LookupDiscoveryManager(new String[]{ "" },
                                       null,
                                       null);
                                       
       Entry[] attributes = new Entry[] {  
              new Name(serviceName),
              new Location("C23","Third Floor" ,"Eng Building" ), 
              new Capacity(max_capacity(),used_capacity()) 
              };
         
        join = new JoinManager(serviceproxy, attributes, 
			       new IDListener(), luMgr, null);
    }


  // This Class makes use of the main method from the class above.. 
  // The only detail that is changing is how you are registering 
  // the service with Jini.. 
  static void usage() {
       System.err.println("Usage: ServiceWrapper " +
                          "[-f] serialization_file" +
                          " servicname");
       System.exit(1);
  }
    
 
   public static void main(String[] args) {
       boolean firsttime = false;
       String serFileName = null;
       File serFile = null;
        
       if (args.length < 2 || args.length > 3) {
            usage();
       }
        
       if (args.length == 3) {
            if (args[0].equals("-f")) {
                firsttime = true;
                serFileName = args[1];
                serviceName = args[2];
            } else {
                usage();
           }
       } else {
            serFileName = args[0];
            serviceName = args[1];
       }
        
       serFile = new File(serFileName);
        
       try {
            System.out.println( "Server Create...");
            FileStoreService fileservice = 
                       (FileStoreService) new FileStoreService();
            System.out.println( "Create Proxy...");
            RemoteResourceServiceProxy serviceproxy = 
                     new RemoteResourceServiceProxy(fileservice);
            
            AttributeServiceWrapper wrapper = 
                  new AttributeServiceWrapper(serviceproxy,
                                             serFile, firsttime);
       } catch (Exception ex) {
            ex.printStackTrace();
       }
  }
}

