package jiniexamples.chapter6;

// The interface for the Service Proxy.. 
import jiniexamples.chapter4.RemoteResourceStore;

import javax.swing.JFrame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import net.jini.lookup.ServiceDiscoveryManager;
import net.jini.lookup.LookupCache;
import net.jini.core.lookup.ServiceTemplate;
import net.jini.core.lookup.ServiceItem;

import java.rmi.RMISecurityManager;
import java.rmi.RemoteException;

public class CachedFileStoreFinder extends FileStoreFinder {

  protected  LookupCache serviceCache;
    
  public CachedFileStoreFinder(ServiceDiscoveryManager sdm, 
                               ServiceTemplate servtmp  ) {
       super (sdm);
       try {
           serviceCache = sdm.createLookupCache(servtmp, null, null);
       } catch (RemoteException e){
           System.out.println ("Remote Exception  " + e);
       }
  }

  // Service Search that uses the cache and  FileServiceFilter
  protected void doServiceSearch(){

       // Get the Search String 
       String searchString = searchField.getText();
    	
       // Set up the search filter to run on the cache
       FileServiceFilter fserv = null;
       if (searchString.length()  != 0) {
           fserv =new FileServiceFilter(searchString);
       }
       ServiceItem[] serviceitems = serviceCache.lookup(fserv , 
                                              Integer.MAX_VALUE);
       serviceList.setListData(serviceitems); 
     }
 
  public static void main (String[] args) {
       try {
           System.setSecurityManager (new RMISecurityManager ());
               
           ServiceDiscoveryManager servmanager = 
                          new ServiceDiscoveryManager(null,null);
           Class[] name = new Class[]{RemoteResourceStore.class};
           ServiceTemplate template = 
                             new ServiceTemplate(null,name,null);
           CachedFileStoreFinder contentPane =
                 new CachedFileStoreFinder(servmanager,template);

           //SWING window Stuff
           JFrame browserframe = new JFrame("Service Finder ");
           browserframe.addWindowListener(new WindowAdapter() {
                 public void windowClosing(WindowEvent e) {
                              System.exit(0);
                 }
           });
           browserframe.setContentPane(contentPane);
           browserframe.pack();
           browserframe.setVisible(true);          
       } catch (Exception e) {
           System.out.println ("client:main() exception: " + e);
       }
  }
}
