package jiniexamples.chapter6;

import net.jini.core.lookup.ServiceItem;
import net.jini.lookup.ServiceItemFilter;
import net.jini.lookup.entry.Name;
import net.jini.core.entry.Entry;

public class FileServiceFilter  implements ServiceItemFilter {
	
  protected String substring;
    
  public FileServiceFilter(String substring) {
       this.substring = substring;
    }
        
  public boolean check(ServiceItem item) {
       Entry[] attrs = item.attributeSets;
       for (int i=0 ; i<attrs.length ; i++) {
          // If it's a Name Attribute or subclass then 
          // compare the Names
          if (Name.class.isAssignableFrom(attrs[i].getClass())) {
           return ((Name)attrs[i]).name.indexOf(substring) != -1;
          }
       }
       return false;
  }    
}
