package jiniexamples.chapter6;

import jiniexamples.chapter4.RemoteResourceStore;

import javax.swing.JButton;
import javax.swing.JList;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import java.awt.Dimension;
import java.awt.BorderLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


import net.jini.lookup.ServiceDiscoveryManager;
import net.jini.core.lookup.ServiceTemplate;
import net.jini.core.lookup.ServiceItem;
import net.jini.core.entry.Entry;
import net.jini.lookup.entry.Name;

import java.rmi.RMISecurityManager;

import java.lang.InterruptedException;
import java.rmi.RemoteException;

public class FileStoreFinder extends JPanel {

  protected final JList serviceList;
  protected JTextField searchField;
  protected ServiceDiscoveryManager serviceManager;
    

  public FileStoreFinder(ServiceDiscoveryManager sdm ) {

       serviceManager = sdm;
       
        // TOOLBAR.
       JPanel toolBar = new JPanel();
        
        // SEARCH Field
       searchField = new JTextField();
       searchField.addActionListener(new ActionListener() {
           public void actionPerformed(ActionEvent e) {
                doServiceSearch();
           }
       });
       
       searchField.setPreferredSize(new Dimension(300, 23));
        
        //SEARCH button
       JButton searchbutton  = new JButton("Search");
       searchbutton.setToolTipText("Search for a service");
       searchbutton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
              doServiceSearch();
            }
       });
        
       toolBar.add(searchField, BorderLayout.WEST);  
       toolBar.add(searchbutton, BorderLayout.EAST);
        
        
        // THE LIST OF SERVICES
       serviceList = new JList(); 
       serviceList.setCellRenderer(new ServiceCellRenderer());
       JScrollPane listPane = new JScrollPane(serviceList);

        //LAY OUT THE VARIOUS COMPONENTS.
       setLayout(new BorderLayout());
       add(toolBar, BorderLayout.NORTH);
       add(listPane, BorderLayout.CENTER);
  }

  protected void doServiceSearch(){

       // Get the Search String 
       String searchString = searchField.getText();
        
       // Set up the search template for Name
       Entry[] atttmp = null;
       if (searchString.length()  != 0) {
             atttmp = new Entry[] {new Name(searchString)}; 
       } 
       Class[] name = new Class[] {RemoteResourceStore.class}; 

       ServiceTemplate template = 
                           new ServiceTemplate(null,name,atttmp);
        
       try {
            //Block until a list of matching services is found
            ServiceItem[] serviceitems = 
                               serviceManager.lookup(template,1, 
                                             Integer.MAX_VALUE, 
                                             null, 2000);
             // Set the list to display
            serviceList.setListData(serviceitems); 
       } catch (RemoteException e) {
            System.out.println ("Search remote  exception: " + e);
       } catch (InterruptedException e) {
            System.out.println (" Interupted exception:" + e);
       }
  }
 
  public static void main (String[] args) {
       
       try {
          System.setSecurityManager (new RMISecurityManager ());
               
          ServiceDiscoveryManager sdm = 
                          new ServiceDiscoveryManager(null,null);
          FileStoreFinder contentPane = new FileStoreFinder(sdm);

           //Swing window Stuff
          JFrame browserframe =
                             new JFrame("Simple Service Finder");
          browserframe.addWindowListener(new WindowAdapter() {
                   public void windowClosing(WindowEvent e) {
                               System.exit(0);
                          }
          });
          browserframe.setContentPane(contentPane);
          browserframe.pack();
          browserframe.setVisible(true);          
       } catch (Exception e) {
          System.out.println ("client:main() exception: " + e);
       }
  }
}
