package jiniexamples.chapter7;

import java.io.Serializable;
import java.rmi.RemoteException;
import net.jini.core.lease.Lease;

public class ChatProxy  implements Chat, Serializable {

  protected ChatHub backend;
    
  public ChatProxy() { // This is not normally called
  }
    
  public ChatProxy(ChatHub  backend){
       this.backend = backend;
  }
    
    // broadcast message
  public void broadcast(String message)  throws RemoteException {
       backend.broadcast(message);
  }
  
    // add a client..
  public Lease register(ChatClient client)  
                                        throws RemoteException {
       return backend.register(client);
  }
}

