package jiniexamples.chapter7;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.util.Enumeration;

import net.jini.core.lease.Lease;
import net.jini.core.lookup.ServiceID;
import net.jini.lookup.ServiceIDListener;

public class ChatServer extends UnicastRemoteObject 
                        implements ChatHub, 
                                   ServiceIDListener {
  
  public final long LEASEDURATION = 2*60*1000L; // 2 Hours
       
  protected transient LandLordImp landlord;
    
  public ChatServer() throws RemoteException {
       landlord  = new LandLordImp();
  }
    
  public Lease register(ChatClient c) throws RemoteException{  	
       try {		
           return landlord.addLease (c, LEASEDURATION);
       } catch (Exception e) {
           System.out.println(" Lease Not granted Exception" +e);
           return null;
       }
  }
    
  public void broadcast (String message) throws RemoteException{
       Enumeration e = landlord.getResources().elements();
       while (e.hasMoreElements()) {
          ManagedLeasedResource managed = 
                       (ManagedLeasedResource) e .nextElement();
          ChatClient destination =(ChatClient) managed.resource;
          destination.sendMessage(message);
       }
  }

  public void serviceIDNotify(ServiceID serviceID) {
       System.out.println("Service started with service ID " 
                           + serviceID.toString());
  } 
}
