package jiniexamples.chapter7;

import net.jini.lookup.ServiceDiscoveryManager;
import net.jini.core.lookup.ServiceTemplate;
import net.jini.core.lookup.ServiceItem;
import net.jini.lease.LeaseListener;
import net.jini.lease.LeaseRenewalEvent;
import net.jini.lease.LeaseRenewalManager;
import net.jini.core.lease.Lease;

import javax.swing.JFrame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import java.rmi.RMISecurityManager;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;


public class GraphicChatClient extends UnicastRemoteObject 
                               implements ChatClient, 
                                          LeaseListener{
	
  static ChatWindow chatPane;
  static Lease lease;
  static ServiceDiscoveryManager sdm;
    
    
  public GraphicChatClient() throws RemoteException{
  }
	

  public void notify(LeaseRenewalEvent e) {
       System.out.println("Lease Event " +e);
  }
 
  public void sendMessage(String message) 
                                        throws RemoteException {
       chatPane.appendMessage(message);
  }
   
  public static void main (String[] args) {
       try {     
           System.setSecurityManager (new RMISecurityManager ());
          
           sdm = new ServiceDiscoveryManager(null,null);  
           // Set up the template 
           Class[] name = new Class[] {Chat.class}; 
           ServiceTemplate template = 
                             new ServiceTemplate(null,name,null);

           ServiceItem serviceitem = 
                      sdm.lookup(template, null, Long.MAX_VALUE);
           
           // Use the Service if has been found.
           if ( serviceitem == null ) {
               System.out.println("Can't find service");
           } else {
               System.out.println(" Servce ID to be used " 
                                  + serviceitem.serviceID);
               GraphicChatClient cl = new GraphicChatClient();
               Chat channelfound = (Chat) serviceitem.service;
               lease = channelfound.register(cl);
                
               sdm.getLeaseRenewalManager().renewFor(lease, 
                                              Lease.FOREVER,cl);
 
               chatPane = new ChatWindow(channelfound);
    	       JFrame browserframe = new JFrame("Simple Chat ");
               browserframe.addWindowListener(
                new WindowAdapter() {
                    public void windowClosing(WindowEvent e) {
                          try { // Cancel the lease
                             LeaseRenewalManager leasemngr =
                                    sdm.getLeaseRenewalManager();
                             leasemngr.cancel(lease);
                          } catch (Exception ex) {
                            System.out.println("Cancel error for"
                                                +lease+ " : "
                                                +ex);
                          }
                          sdm.terminate();
                          System.exit(0); 
                   }
             });
        	
             browserframe.setContentPane(chatPane);
             browserframe.pack();
            browserframe.setVisible(true);   
           }
             
       } catch (Exception e) {
           System.out.println ("client: main() exception: " + e);
       }
  }      
}

