package jiniexamples.chapter7;

import com.sun.jini.lease.landlord.Landlord;
import com.sun.jini.lease.landlord.LeasedResource;
import com.sun.jini.lease.landlord.LandlordLease;
import net.jini.core.lease.LeaseException;
import net.jini.core.lease.LeaseDeniedException;
import net.jini.core.lease.UnknownLeaseException;
import net.jini.core.lease.Lease; 
import java.rmi.server.UnicastRemoteObject;
import java.util.Map;
import java.util.Vector;

public class LandLordImp  extends UnicastRemoteObject implements Landlord {

  LeaseManagerImpl manager = null;

  public LandLordImp() throws java.rmi.RemoteException {
	manager = new LeaseManagerImpl(this);
    }
    
  // ========= LandLord Lease  Interface======================    
    public void cancel(Object cookie) {
	manager.cancel(cookie);
    }

  public Map cancelAll(Object[] cookies) {
	return manager.cancelAll(cookies);
  }

  public long renew(java.lang.Object cookie, long extension) 
	    throws LeaseDeniedException, UnknownLeaseException {
		
       LeasedResource resource = manager.getResource(cookie);
       if (resource != null) {
           return manager.getPolicy().renew(resource, extension);
       }
       throw new UnknownLeaseException();
  }


  public Landlord.RenewResults renewAll(Object[] cookies,
                                        long[] extension) {
					  
       // Renew each resource catch exceptions and build up 
       // the LandLord.RenewResults ..
       Exception deny_leases[] = new Exception [cookies.length];
       long grant_leases[] = new long[cookies.length];
	
       for ( int i=0; i<cookies.length;i ++) {
          try {
             grant_leases[i] = renew(cookies[i], extension[i]);
          } catch (LeaseException e){
             grant_leases[i] = -1;
             deny_leases[i] = e;
          }
       }
       return new Landlord.RenewResults(grant_leases,deny_leases);
  }     
    // ========================================================
    
  // This creates a new lease 
  public LandlordLease addLease(Object resource, long duration) 
                                    throws LeaseDeniedException {
                                    	
       ManagedLeasedResource r = 
                            new ManagedLeasedResource(resource);

                           
       return (LandlordLease) manager.getPolicy().leaseFor(r, 
                                                       duration);
  }
    
  public Vector getResources() {
       return manager.managedResources();
  }
    
}
