 // This is the class associated with handling events. 
 // This uses the RMI infrastructure to allow it to be called 
 // from the file store server 

package jiniexamples.chapter8;

import net.jini.core.lookup.ServiceID;
import net.jini.core.event.RemoteEvent;
import net.jini.core.event.RemoteEventListener;
import java.awt.Component;
import java.awt.Color;
import java.util.Hashtable;

import java.rmi.server.UnicastRemoteObject;
import java.rmi.RemoteException;
 
public class FileUseHandler extends UnicastRemoteObject
                            implements RemoteEventListener {
        
    protected Hashtable indicatorList;
      
    public FileUseHandler() throws RemoteException {
    }

    public FileUseHandler(Hashtable services) 
                                        throws RemoteException {
        indicatorList= services;
    }
    
    public void notify(RemoteEvent e) {
        	
        FileUseEvent evt = (FileUseEvent)e;
        ServiceID servID = (ServiceID)evt.eventData;
        
        Component serv_entry = 
                            (Component)indicatorList.get(servID);       
        if (serv_entry != null) {
           for (int i =0 ; i< 10; i++){
              serv_entry.setBackground(Color.green );
              for (int n =0 ; n< 500; n++){}
              serv_entry.setBackground(Color.white );
           }
        }
    }
}
