package jiniexamples.chapter8;

import net.jini.core.entry.Entry;
import net.jini.lookup.JoinManager;
import net.jini.discovery.LookupDiscoveryManager;
import net.jini.lookup.entry.Name;
import java.io.IOException;
import java.rmi.RMISecurityManager;

public class ServiceWrapper   {

  public ServiceWrapper() {
  }
  

  static void usage() {
    System.err.println("Usage: ServiceWrapper servicename");
    System.exit(1);
  }

  public static void main(String[] args) {
  	
     if (args.length != 1) {
   	usage();
     }
    	
     if (System.getSecurityManager() == null) {
         System.setSecurityManager( new RMISecurityManager());
     }
    	
     Entry[] attributes =  null;
     
     try{
         FileStoreService fileservice = new FileStoreService();
         RemoteResourceServiceProxy serviceproxy = 
                  new RemoteResourceServiceProxy(fileservice,
                                         fileservice.getRoot());
            
         attributes = new Entry[] { new Name(args[0])};
        
         String[] allgroups = new String[] { "" };
         LookupDiscoveryManager discoverymanager = 
               new LookupDiscoveryManager(allgroups, null, null);
                                                      
         JoinManager join = new JoinManager(serviceproxy, 
                                            attributes, 
                                            fileservice, 
                                            discoverymanager, 
                                            null);           
    } catch (Exception ex) {
        ex.printStackTrace();
    }
  }
}
